# This code has been developed under THALIS: MATENVMED project for Action 4.3 and co-financed by Greece and EU - NSRF 2007-2013.
# Wave python module uses linear interpolation for wave location inside the finite element 

import numpy as np
  
def Wave(p1,p2,p3,p):
    # Valid only for p between p1 and p2
    t1=[p2[0]-p1[0], p2[1]-p1[1],p2[2]-p1[2]]
    t2=[p3[0]-p1[0], p3[1]-p1[1],p3[2]-p1[2]]
    t3=[p3[0]-p2[0], p3[1]-p2[1],p3[2]-p2[2]]
    plane=np.cross(t1,t2)
    D=plane[0]*p1[0]+plane[1]*p1[1]+plane[2]*p1[2]-plane[2]*p[2]
    A1=np.array([[plane[0], plane[1]],[t2[1],-t2[0]]])
    A2=np.array([[plane[0], plane[1]],[t3[1],-t3[0]]])
    b1=np.array([D,p1[0]*t2[1]-p1[1]*t2[0]])
    b2=np.array([D,p2[0]*t3[1]-p2[1]*t3[0]])
    x1 = np.linalg.solve(A1, b1)
    x2 = np.linalg.solve(A2, b2)
    kx=(x1[0]-p1[0])/(p3[0]-p1[0])
    ky=(x1[1]-p1[1])/(p3[1]-p1[1])
    if (0<=kx and 0<=ky and kx<=1 and ky<=1):
        pnew=x1
        #  p-New between p1 and p3
        fp=13
    else:
        pnew=x2
        #  p-New between p2 and p3
        fp=23
    return pnew,fp
